﻿using Monorail.DrawningObjects;
using Monorail.Generics;
using Monorail.MovementStrategy;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Monorail
{
    public partial class FormMonorailCollection : Form
    {
        private readonly MonorailGenericCollection<DrawningMonorail, DrawningObjectMonorail> _monorails;

        public FormMonorailCollection()
        {
            InitializeComponent();
            _monorails = new MonorailGenericCollection<DrawningMonorail,
DrawningObjectMonorail>(pictureBoxCollection.Width, pictureBoxCollection.Height);
        }

        private void addMonorailButton_Click(object sender, EventArgs e)
        {
            MonorailForm form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_monorails + form.SelectedMonorail != null)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _monorails.ShowMonorails();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }

            }
        }

        private void deleteMonorailButton_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление",
MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBox.Text);
            if (_monorails - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _monorails.ShowMonorails();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }

        private void updateCollectionButton_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _monorails.ShowMonorails();

        }
    }
}
